﻿using System;
using System.Threading;
using Gsiot.CosmClient;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Mountaineer.Netmf.Hardware;

// connect an analog input to pin 3 of socket 6,
// e.g., a GHI Potentiometer module

public class HelloCosm
{
    public static void Main()
    {
        const string apiKey = "624f01ac0c72d42dc801ef7b5e10b1ba3de7dbb44dfcf16a1d074aacfbbdae5b";
        const string feedId = "21293";
        //const string apiKey = "<insert your API key here>";
        //const string feedId = "<insert your feed ID here>";
        const int samplingPeriod = 20000;   // 20 seconds

        var voltagePort = new AnalogInput(Socket6.AnalogInput3);
        voltagePort.Scale = 3.3;                    // convert to Volt

        while (true)
        {
            WaitUntilNextPeriod(samplingPeriod);
            double value = voltagePort.Read();
            string sample = "voltage," + value.ToString("f");
            Debug.Print("new message: " + sample);
            CosmClient.Send(apiKey, feedId, sample);
        }
    }

    static void WaitUntilNextPeriod(int period)
    {
        long now = DateTime.Now.Ticks / TimeSpan.TicksPerMillisecond;
        var offset = (int)(now % period);
        int delay = period - offset;
        Debug.Print("sleep for " + delay + " ms\r\n");
        Thread.Sleep(delay);
    }
}
